<?php

namespace Drupal\oswald\Form;

use Drupal\Core\Entity\ContentEntityForm;
use Drupal\Core\Form\FormStateInterface;

/**
 * Form controller for oswald_chatbot edit forms.
 */
class OswaldChatbotForm extends ContentEntityForm {

  /**
   * {@inheritdoc}
   */
  public function buildForm(array $form, FormStateInterface $form_state) {
    return parent::buildForm($form, $form_state);
  }

  /**
   * {@inheritdoc}
   */
  protected function actions(array $form, FormStateInterface $form_state) {
    $element = parent::actions($form, $form_state);

    $account = \Drupal::currentUser();
    $element['delete']['#access'] = $account->hasPermission('administer oswald configuration');
    $element['delete']['#weight'] = 100;

    return $element;
  }

  /**
   * {@inheritdoc}
   */
  public function save(array $form, FormStateInterface $form_state) {
    $entity = $this->entity;
    $status = $entity->save();

    switch ($status) {
      case SAVED_NEW:
        $this->messenger()->addStatus($this->t('Created the %label Oswald chatbot.', [
          '%label' => $entity->get('name')->value,
        ]));
        break;

      default:
        $this->messenger()->addStatus($this->t('Saved the %label Oswald chatbot.', [
          '%label' => $entity->get('name')->value,
        ]));
        break;
    }

    $form_state->setRedirect('entity.oswald_chatbot.collection');
  }

}
